#!/usr/bin/perl
# 5630-A36,  (C) COPYRIGHT International Business Machines Corp., 2002
# All Rights Reserved * Licensed Materials - Property of IBM

# use the Perl socket object library
#
use IO::Socket::INET;

# the default port for lbwebaccess is 1104
#
$lbwebaccess_port = 1104;

# grab the command from the request (GET method), cleaning up any URL encoding
#
$command = $ENV{'QUERY_STRING'};

$lbwebaccess = IO::Socket::INET->new (Proto    => 'tcp',
                                      PeerAddr => 'localhost',
                                      PeerPort => $lbwebaccess_port);

# use communication streams in raw mode (don't do any CRLF conversion)
#
binmode ($lbwebaccess, ":raw");
binmode (STDOUT,       ":raw");

# make sure that the socket opened
#
unless ($lbwebaccess) {

  print "Content-type: text/plain\n\n";
  print "ERROR_NO_WEB_SERVICE\n";

  die "could not communicate with lbwebaccess";
}

# send the command over the socket to lbwebaccess
#
print $lbwebaccess "$command\n";

# since we're talking HTTP, we need a content type; we're not really returning
# a "text/plain" response, but so what
#
print "Content-type: text/plain\n\n";

# read from the socket; we want to proxy the output from lbwebaccess back to
# the original requester
#
$buffer_size = 64;
$read        = -1;

while ($read != 0) {

  $read = read ($lbwebaccess, $buffer, $buffer_size);
  if ($read > 0) {print $buffer}
}

exit 0;
